<?php

namespace Drupal\blockfrost\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\key\Entity\Key;

class BlockfrostSettingsForm extends ConfigFormBase {

  protected function getEditableConfigNames() {
    return ['blockfrost.settings'];
  }

  public function getFormId() {
    return 'blockfrost_settings_form';
  }

  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->config('blockfrost.settings');

    $key_options = [];
    $keys = Key::loadMultiple();
    foreach ($keys as $key) {
      $key_options[$key->id()] = $key->label();
    }

    $form['key_id'] = [
      '#type' => 'select',
      '#title' => $this->t('Blockfrost API Key'),
      '#options' => $key_options,
      '#default_value' => $config->get('key_id'),
      '#required' => TRUE,
    ];

    return parent::buildForm($form, $form_state);
  }

  public function submitForm(array &$form, FormStateInterface $form_state) {
    $this->config('blockfrost.settings')
      ->set('key_id', $form_state->getValue('key_id'))
      ->save();

    parent::submitForm($form, $form_state);
  }
}
